#ifndef SORTED_MAP
#define SORTED_MAP
enum nodetype { LEAF, INTERN };

typedef struct node {
	enum nodetype type;
	char * key;
} SortedMap;

SortedMap * map();
void * get_map(SortedMap *this, char *key);
SortedMap * put_map(SortedMap *this, char *key, void *value);
void print_map(SortedMap *this);
void free_mapvalues(SortedMap *this);
void free_map(SortedMap *this);
#endif
